<template>
  <div>
    <v-container>
      <v-layout>
        <v-flex md12>
                <v-card color="blue-grey darken-2" class="white--text">
                  <v-layout>
                    <v-flex xs5>
                      <v-img
                        src="https://www.logolynx.com/images/logolynx/e1/e100b3fc2a67a1e91b72f50277746b97.jpeg"
                        height="100px"
                        contain
                      ></v-img>
                    </v-flex>
                    <v-flex xs7>
                      <v-card-title primary-title>
                        <div>
                          <div class="headline">{{currentEmployee.name}} {{currentEmployee.surname}}</div>
                          <div>Email: {{currentEmployee.email}}</div>
                          <div>Workplace: {{currentEmployee.workplace}}</div>
                          <div>Projects: {{currentEmployee.project}}</div>
                        </div>
                      </v-card-title>
                    </v-flex>
                    <v-flex xs3></v-flex>
                    <v-flex xs2>
                      <v-btn
                        flat color="white"
                        @click.stop="changeEmployeeDialog = true"
                      >
                        <v-icon>edit</v-icon>
                      </v-btn>
                      <v-btn
                        flat color="white"
                        @click.stop="deleteEmployeeDialog = true"
                      >
                        <v-icon>delete_forever</v-icon>
                      </v-btn>
                    </v-flex>
                  </v-layout>
                  <v-divider light></v-divider>
                </v-card>
              </v-flex>
      </v-layout>
      <br>
    <v-tabs
      color="blue-grey darken-2"
      dark
      slider-color="yellow">
        <v-tab>
          Info
        </v-tab>
      <v-tab>
          Skills
        </v-tab>
        <v-tab-item>
          <v-card>
                        <v-flex>
                        <v-card color="blue-grey lighten-3">
                          <v-layout>
                            <v-flex>
                              <v-card-title primary-title>
                                <div>
                                  <div class="headline">Personal info: </div>
                                    <v-card-text align="left">
                                     <div> ID: {{currentEmployee.id}} </div>
                                      <div>Start date: {{currentEmployee.startDate}}</div>
                                      <div>Gender: {{currentEmployee.gender}}</div>
                                      <div>Birthday: {{currentEmployee.birthday}}</div>
                                    </v-card-text>
                                  </div>
                              </v-card-title>
                             </v-flex>
                           </v-layout>
                      <v-divider light></v-divider>
                    </v-card>
                        </v-flex>
                    </v-card>
          <v-card>
                        <v-flex>
                        <v-card color="blue-grey lighten-3">
                          <v-layout>
                            <v-flex>
                              <v-card-title primary-title>
                                <div>
                                  <div class="headline">Job details: </div>
                                    <v-card-text align="left">
                                     <div> Job title: {{currentEmployee.jobTitle}} </div>
                                      <div>Supervisor: {{currentEmployee.supervisor}} </div>
                                      <div>Department: {{currentEmployee.department}}</div>
                                    </v-card-text>
                                  </div>
                              </v-card-title>
                             </v-flex>
                           </v-layout>
                      <v-divider light></v-divider>
                    </v-card>
                        </v-flex>
                    </v-card>
        </v-tab-item>
      <v-tab-item>
        <v-card>

        <v-flex>
        <v-card color="blue-grey lighten-3">
        <v-layout>
        <v-flex>
          <v-card color="blue-grey lighten-3" class="white--text">
              <v-btn @click.stop="openAddSkillDialog">
                <v-icon>library_add</v-icon>
              </v-btn>
              <v-data-table
                light
                :headers="headers"
                :items="items"
                :item-key="id">
                <template slot="items" slot-scope="props">
                  <tr>
                    <td class="text-xs">{{ props.item.title }}</td>
                    <td class="text-xs">
                      <v-rating
                        v-model="props.item.level"
                        background-color="blue-grey lighten-3"
                        v-bind:color="props.item.color"
                        small
                        v-bind:readonly="props.item.readonly"
                      ></v-rating>
                    </td>
                    <td class="text-xs">{{ props.item.dateUpdate }}</td>
                    <td>
                      <v-icon @click="toggleEditMode(props.item)">{{props.item.icon}}</v-icon>
                      <v-icon @click="refreshDeletedSkillIdAndOpenDeleteDialog(props.item.id)">delete</v-icon>
                    </td>
                  </tr>
            </template>
              </v-data-table>
          </v-card>
          </v-flex>
          </v-layout>
          <v-divider light></v-divider>
          </v-card>
          </v-flex>
          </v-card>
        </v-tab-item>
      </v-tabs>
      <v-layout justify-center>
      <v-dialog
        v-model="dialog"
        max-width="400">
        <v-card>
          <h2>Add skill to employee</h2>
          <v-card-text>
            <v-flex>
            <v-select
              :items="skillsItems"
              v-model="addedSkill.title"
              :menu-props="{ maxHeight: '400' }"
              label="Skill"
              hint="Pick skill"
              required
              persistent-hint>
            </v-select>
          </v-flex>
            <v-flex>
              <v-rating
                background-color="blue-grey lighten-3"
                v-model="addedSkill.level"
                color="blue-grey lighten-1"
                small
                required
              ></v-rating>
            </v-flex>
          </v-card-text>
          <div align="center">
            <v-spacer></v-spacer>
            <v-btn
              color="blue-grey darken-3"
              flat="flat"
              @click="cancelAddSkill()">
              Cancel
            </v-btn>
            <v-btn
              color="blue-grey darken-3"
              flat="flat"
              @click="addSkillToEmployee()">
              Add
            </v-btn>
        </div>
          <div>
            <p style="color: red">{{addSkillToEmployeeErrorMsg}}</p>
          </div>
        </v-card>
      </v-dialog>
    </v-layout>
      <!--edit dialog-->
      <v-layout justify-center>
      <v-dialog
        v-model="changeEmployeeDialog"
        max-width="900">
        <v-card>
          <h2>Edit employee</h2>
          <v-card-text>
            <v-form>
              <v-flex>
                <v-text-field
                  v-bind:placeholder="currentEmployee.name"
                  v-model="editEmployee.name"
                  label="Name"
                  required
                ></v-text-field>
              </v-flex>
              <v-flex>
                <v-text-field
                  v-bind:placeholder="currentEmployee.surname"
                  v-model="editEmployee.surname"
                  label="Surname"
                  required
                ></v-text-field>
              </v-flex>
              <v-flex>
                <v-text-field
                  v-bind:placeholder="currentEmployee.startDate"
                  v-model="editEmployee.startDate"
                  label="Start date"
                  required
                ></v-text-field>
              </v-flex>
              <v-flex>
              <v-select
                v-bind:placeholder="currentEmployee.gender"
                v-model="editEmployee.gender"
                :items="genders"
                :menu-props="{ maxHeight: '400' }"
                label="Gender"
                persistent-hint>
              </v-select>
              </v-flex>
              <v-flex>
                <v-text-field
                  v-bind:placeholder="currentEmployee.birthday"
                  v-model="editEmployee.birthday"
                  label="Birthday"
                  required
                ></v-text-field>
              </v-flex>
              <v-flex>
                <v-text-field
                  v-bind:placeholder="currentEmployee.email"
                  v-model="editEmployee.email"
                  label="Email"
                  required
                ></v-text-field>
              </v-flex>
              <v-flex>
              <v-select
                v-bind:placeholder="currentEmployee.employeeSkills"
                v-model="editEmployee.employeeSkills"
                :items="employeeSkills"
                :menu-props="{ maxHeight: '400' }"
                label="Skills"
                multiple
                persistent-hint>
              </v-select>
              </v-flex>
                <v-flex>
                  <v-text-field
                    v-bind:placeholder="currentEmployee.project"
                    v-model="editEmployee.project"
                    label="Project"
                    required>
                  </v-text-field>
                </v-flex>
               <v-flex>
                  <v-text-field
                    v-bind:placeholder="currentEmployee.jobTitle"
                    v-model="editEmployee.jobTitle"
                    label="Job title"
                    required>
                  </v-text-field>
                </v-flex>
                <v-flex>
                  <v-text-field
                    v-bind:placeholder="currentEmployee.department"
                    v-model="editEmployee.department"
                    label="Department"
                    required>
                  </v-text-field>
                </v-flex>
              <v-flex>
                  <v-text-field
                    v-bind:placeholder="currentEmployee.workplace"
                    v-model="editEmployee.workplace"
                    label="Workplace"
                    required>
                  </v-text-field>
                </v-flex>
                <v-flex>
                  <v-text-field
                    v-bind:placeholder="currentEmployee.position"
                    v-model="editEmployee.position"
                    label="Position"
                    required>
                  </v-text-field>
                </v-flex>
              <v-flex>
                  <v-text-field
                    v-bind:placeholder="currentEmployee.currentManager"
                    v-model="editEmployee.currentManager"
                    label="Current manager"
                    required>
                  </v-text-field>
                </v-flex>
              <v-flex>
                  <v-text-field
                    v-bind:placeholder="currentEmployee.supervisor"
                    v-model="editEmployee.supervisor"
                    label="Supervisor"
                    required>
                  </v-text-field>
                </v-flex>
            </v-form>
          </v-card-text>
          <div align="center">
            <v-spacer></v-spacer>
            <v-btn
              color="blue-grey darken-3"
              flat="flat"
              @click="changeEmployeeDialog = false; editErrorMsg = ''">
              Cancel
            </v-btn>
            <v-btn
              color="blue-grey darken-3"
              flat="flat"
              @click="changeEmployee">
              Save
            </v-btn>
         </div>
          <div>
            <p style="color: red">{{editErrorMsg}}</p>
          </div>
        </v-card>
      </v-dialog>
    </v-layout>
      <v-layout justify-center>
      <v-dialog
        v-model="deleteEmployeeDialog"
        max-width="300">
        <v-card>
          <h2>Delete employee</h2>
          <v-card-text>
            <h3>Are you sure?</h3>
          </v-card-text>
            <v-spacer></v-spacer>
            <div align="center">
              <v-btn
                color="blue-grey darken-3"
                flat="flat"
                @click="deleteEmployeeDialog = false; deleteErrorMsg = ''">
                Cancel
              </v-btn>
              <v-btn
                color="blue-grey darken-3"
                flat="flat"
                @click="deleteEmployee">
                Delete
              </v-btn>
              </div>

          <div>
            <p style="color: red">{{deleteErrorMsg}}</p>
          </div>
        </v-card>
      </v-dialog>
    </v-layout>
      <v-spacer></v-spacer>
      <v-layout justify-center>
      <v-dialog
        v-model="deleteSkillDialog"
        max-width="300">
        <v-card>
          <h2>Delete skill</h2>
          <v-card-text>
            <h3>Are you sure?</h3>
          </v-card-text>
            <v-spacer></v-spacer>
            <div align="center">
              <v-btn
                color="blue-grey darken-3"
                flat="flat"
                @click.stop="deleteSkillDialog = false; deleteSkillErrorMsg = ''">
                Cancel
              </v-btn>
              <v-btn
                color="blue-grey darken-3"
                flat="flat"
                @click.stop="deleteSkill">
                Delete
              </v-btn>
              </div>
          <div>
            <p style="color: red">{{deleteSkillErrorMsg}}</p>
          </div>
        </v-card>
      </v-dialog>
    </v-layout>
    </v-container>
  </div>
</template>

<script>

export default {
  name   : 'EmployeeBasic',
  data () {
    return {
      changeEmployeeDialog      : false,
      deleteEmployeeDialog      : false,
      editErrorMsg              : '',
      deleteErrorMsg            : '',
      editSkillDialog           : false,
      editSkillErrorMsg         : '',
      deleteSkillDialog         : false,
      deleteSkillErrorMsg       : '',
      addSkillToEmployeeErrorMsg: '',
      currentEmployee           : {
        id            : '',
        name          : '',
        surname       : '',
        startDate     : '',
        gender        : '',
        birthday      : '',
        email         : '',
        skills        : [],
        project       : '',
        jobTitle      : '',
        department    : '',
        workplace     : '',
        position      : '',
        currentManager: '',
        supervisor    : ''
      },
      editEmployee              : {
        id            : '',
        name          : '',
        surname       : '',
        startDate     : '',
        gender        : '',
        birthday      : '',
        email         : '',
        skills        : [],
        project       : '',
        jobTitle      : '',
        department    : '',
        workplace     : '',
        position      : '',
        currentManager: '',
        supervisor    : ''
      },
      dialog                    : false,
      skillsTypes               : ['SkillType1', 'SkillType2'],
      skillsCategories          : ['Cat1', 'Cat2'],
      skillsItems               : [],
      headers                   : [
        {
          text: 'Skill', value: 'skill', align: 'center'
        },
        {
          text: 'Level', value: 'level', align: 'center'
        },
        {
          text: 'Date update', value: 'date update', align: 'center'
        },
        {
          text: 'Actions', value: 'actions', align: 'center'
        }
      ],
      items                     : [
        // {id: 0, skill: 'jQuery', level: 4, dateUpdate: '01-01-1970'},
        // {id: 1, skill: 'JavaScript', level: 5, dateUpdate: '01-01-1970'},
        // {id: 2, skill: 'PowerPoint', level: 3, dateUpdate: '01-01-1970'}
      ],
      addedSkill                : {
        id   : '',
        title: '',
        level: '2'
      },
      deletedSkillId            : 0
    }
  },
  mounted () {
    // find employee in store by id
    // let id = this.$route.params.id
    // let found = null
    // let employees = this.$store.getters.getEmployees
    // for (let i = 0; i < employees.length; i++) {
    //   if (employees[i].id == id) {
    //     // alert('found at i = ' + i)
    //     found = employees[i]
    //     break
    //   }
    // }
    let found = this.findEmployeeInStore()
    // alert('found = ' + found)
    if (found) {
      this.currentEmployee = found
      // finding employee skills
      let skills = found.skills
      this.items = []
      const date = new Date()
      for (let i = 0; i < skills.length; i++) {
        //todo: make real level
        this.items.push({
          id        : skills[i].id,
          title     : skills[i].title,
          level     : skills[i].level,
          readonly  : true,
          color     : 'blue-grey lighten-3',
          icon      : 'edit',
          dateUpdate: date.toISOString()
        })
      }
    }
    this.refreshSkillsArr()
  },
  methods: {
    findEmployeeInStore () {
      let id = this.$route.params.id
      let found = null
      let employees = this.$store.getters.getEmployees
      for (let i = 0; i < employees.length; i++) {
        if (employees[i].id == id) {
          // alert('found at i = ' + i)
          found = employees[i]
          break
        }
      }
      return found
    },
    cancelAddSkill () {
      this.addedSkill = {
        id   : '',
        title: '',
        level: '2'
      };
      this.addSkillToEmployeeErrorMsg = '';
      this.dialog = false
    },
    openAddSkillDialog () {
      this.addSkillToEmployeeErrorMsg = '';
      this.refreshSkillsArr()
      this.dialog = true
    },
    refreshSkillsArr () {
      // alert('refresh skills arr!')
      let oldSkills = []
      let empFromStore = this.findEmployeeInStore()
      if (empFromStore) {
        let empSkills = empFromStore.skills
        for (let i = 0; i < empSkills.length; i++) {
          oldSkills.push(empSkills[i])
        }
        // alert('old skills: ' + oldSkills)
        this.skillsItems = []
        let skillsArr = this.$store.getters.getSkills
        // alert('skills from store:' + skillsArr)
        let skillsArrLen = skillsArr.length
        for (let i = 0; i < skillsArrLen; i++) {
          // check if already represented
          let found = false
          for (let j = 0; j < oldSkills.length; j++) {
            // alert('oldSkills[j].title=' + oldSkills[j] + ' skillsArr[i].title=' + skillsArr[i].title)
            if (oldSkills[j].title === skillsArr[i].title) {
              // alert('found!' + oldSkills[j] + ' represented!')
              found = true
              break
            }
          }
          if (!found) {
            // alert('coincidence not found for ' + skillsArr[i])
            this.skillsItems.push(skillsArr[i].title)
          }
        }
        // alert('new skills arr: ' + this.skillsItems)
      }
    },
    changeEmployee () {
      let id = this.$route.params.id
      let employees = this.$store.getters.getEmployees
      for (let i = 0; i < employees.length; i++) {
        if (employees[i].id == id) {
          employees[i] = {
            // todo: add real data
            id            : this.$route.params.id,
            name          : this.editEmployee.name ? this.editEmployee.name : this.currentEmployee.name,
            surname       : this.editEmployee.surname ? this.editEmployee.surname : this.currentEmployee.surname,
            startDate     : this.editEmployee.startDate ? this.editEmployee.startDate : this.currentEmployee.startDate,
            gender        : this.editEmployee.gender ? this.editEmployee.gender : this.currentEmployee.gender,
            birthday      : this.editEmployee.birthday ? this.editEmployee.birthday : this.currentEmployee.birthday,
            email         : this.editEmployee.email ? this.editEmployee.email : this.currentEmployee.email,
            skills        : this.editEmployee.skills ? this.editEmployee.skills : this.currentEmployee.skills,
            project       : this.editEmployee.project ? this.editEmployee.project : this.currentEmployee.project,
            jobTitle      : this.editEmployee.jobTitle ? this.editEmployee.jobTitle : this.currentEmployee.jobTitle,
            department    : this.editEmployee.department ? this.editEmployee.department : this.currentEmployee.department,
            workplace     : this.editEmployee.workplace ? this.editEmployee.workplace : this.currentEmployee.workplace,
            position      : this.editEmployee.position ? this.editEmployee.position : this.currentEmployee.position,
            currentManager: this.editEmployee.currentManager ? this.editEmployee.currentManager : this.currentEmployee.currentManager,
            supervisor    : this.editEmployee.supervisor ? this.editEmployee.supervisor : this.currentEmployee.supervisor,
          }
          this.$store.commit('editEmployee', {data: employees[i]})
          this.changeEmployeeDialog = false
          this.currentEmployee = employees[i]
          this.editErrorMsg = ''
          return
        }
      }
      this.editErrorMsg = 'Oops! Something goes wrong'
    },
    deleteEmployee () {
      let id = this.$route.params.id
      this.$store.commit('deleteEmployee', {data: {id: id}})
      this.deleteErrorMsg = ''
      this.deleteEmployeeDialog = false
      this.$router.push('/main/emplist')
    },
    // editSkill (skillId) {
    //   alert('edit skill ' + skillId)
    //   this.editSkillDialog = false
    // },
    refreshDeletedSkillIdAndOpenDeleteDialog (skillId) {
      this.deletedSkillId = skillId
      this.deleteSkillDialog = true
    },
    deleteSkill () {
      // delete skill
      let arr = this.currentEmployee.skills
      for (let i = 0; i < arr.length; i++) {
        if (arr[i].id === this.deletedSkillId) {
          this.currentEmployee.skills.splice(i, 1)
          // refresh skills table
          this.items.splice(i, 1)
          // commit
          this.$store.commit('editEmployee', {
            data: this.currentEmployee
          })

          this.deleteSkillDialog = false
          break
        }
      }
      this.deleteSkillDialog = false
    },
    toggleEditMode (prop) {
      prop.readonly = !prop.readonly
      prop.color = prop.color === 'blue-grey lighten-1' ? 'blue-grey lighten-3' : 'blue-grey lighten-1'
      if (prop.icon === 'save') {
        // find skill
        let arr = this.currentEmployee.skills
        for (let i = 0; i < arr.length; i++) {
          if (arr[i].id == prop.id) {
            this.currentEmployee.skills[i] = {
              id   : prop.id,
              title: prop.title,
              level: prop.level
            }
            this.$store.commit('editEmployee', {
              data: this.currentEmployee
            })
            break
          }
        }
      }
      prop.icon = prop.icon === 'edit' ? 'save' : 'edit'
      const date = new Date()
      prop.dateUpdate = date.toISOString()
    },

    addSkillToEmployee () {
      this.addSkillToEmployeeErrorMsg = '';
      if (!this.addedSkill.title) {
        this.addSkillToEmployeeErrorMsg = 'Pick skill please!';
        return;
      }
      // todo: check if already exists (or unique)
      let generatedId = Math.floor(Math.random() * 10000)
      this.currentEmployee.skills.push({
        id   : generatedId,
        title: this.addedSkill.title,
        level: this.addedSkill.level
      })
      this.$store.commit('editEmployee', {
        data: this.currentEmployee
      })
      // refresh skills table todo: IN ALL PLACES!
      const date = new Date()
      this.items.push({
        id        : generatedId,
        title     : this.addedSkill.title,
        level     : this.addedSkill.level,
        readonly  : true,
        color     : 'blue-grey lighten-3',
        icon      : 'edit',
        dateUpdate: date.toISOString()
      })
      this.addedSkill = {
        id   : '',
        title: '',
        level: '2'
      }
      this.dialog = false;
    }
  }
}
</script>

<style scoped>
  h2 {
    font-family    : 'Avenir', Helvetica, Arial, sans-serif;
    padding-top    : 10px;
    padding-bottom : 20px;
    display        : inline-block;
  }
</style>
